import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.CellValue;
import org.apache.poi.ss.usermodel.FormulaEvaluator;
import org.apache.poi.ss.usermodel.Name;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.ss.util.CellReference;

public class Main {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws IOException {
        try (Workbook xSSFWorkbook = new org.apache.poi.xssf.usermodel.XSSFWorkbook()) {
            final FormulaEvaluator evaluator = xSSFWorkbook.getCreationHelper().createFormulaEvaluator();            
            final Sheet createSheet = xSSFWorkbook.createSheet("Sheet1");
            final Name createName = xSSFWorkbook.createName();
            final int sheetIndex = xSSFWorkbook.getSheetIndex(createSheet);
            createName.setNameName("CURRENT_ROW_COLUMN_A");
            createName.setSheetIndex(sheetIndex);
            final CellReference cellReference = new CellReference(createSheet.getSheetName(), 0, 0, false, true);
            final String formatAsString = cellReference.formatAsString(true);
            createName.setRefersToFormula(formatAsString);
            for (int i = 0; i < 10; i++) {
                final Row createRow = createSheet.createRow(i);
                final Cell cellWithConstant = createRow.getCell(0, Row.MissingCellPolicy.CREATE_NULL_AS_BLANK);
                cellWithConstant.setCellValue(i + 1);
                final Cell cellWithFormula = createRow.getCell(1, Row.MissingCellPolicy.CREATE_NULL_AS_BLANK);
                final String formula = createName.getNameName()+"+1000";
                cellWithFormula.setCellFormula(formula);
                final CellValue evaluate = evaluator.evaluate(cellWithFormula);
                final Cell cellWithComputedResult = createRow.getCell(2, Row.MissingCellPolicy.CREATE_NULL_AS_BLANK);
                cellWithComputedResult.setCellValue(evaluate.getNumberValue());
                final Cell cellWithCheckFormula = createRow.getCell(3, Row.MissingCellPolicy.CREATE_NULL_AS_BLANK);
                final String checkFormula = cellWithFormula.getAddress().toString()+"="+cellWithComputedResult.getAddress().formatAsString();
                cellWithCheckFormula.setCellFormula(checkFormula);
            }   
            final File testFile = new File("test.xlsx");
            final FileOutputStream fos = new FileOutputStream(testFile);
            xSSFWorkbook.write(fos);
        }
    }
    
}
